#ifndef ESP32_FIREWALL_HPP
#define ESP32_FIREWALL_HPP

#include "FirewallTypes.h"
#include "esp32Storage.hpp"
#include "WString.h"

namespace firewall
{
    class Firewall : public Storage
    {
    protected:
        uint8_t amount_of_rules = 0;
        struct firewall_rule *head = NULL;

        void add_rule_to_firewall(firewall_rule_t *);
        firewall_rule_t *get_rule_from_firewall(uint8_t);
        bool delete_rule_from_firewall(uint8_t);

        String protocol_to_string(firewall_protocol_t &protocol);
        firewall_protocol_t string_to_protocol(std::string &protocol);
        String target_to_string(firewall_target_t &target);
        firewall_target_t string_to_target(std::string &target);

    public:
        Firewall();
        ~Firewall();
    };
}

#endif
